--[[
	Version: 1.2
	Supported oUF Version: 1.3.1

	Based Code provided by oUF_Lily

	Credits to
	P3lim and Caellian 
	-- for letting me use some of their code to modify the layout
	 
	Haste
	-- for oUF and oUF_Lily

	Supported Plugins
	-- oUF_BarFader
	-- oUF_DebuffHighlight
	-- oUF_Experience
	-- oUF_CombatFeedback
	-- oUF_Smooth
	
	
]]
local texture = "Interface\\AddOns\\oUF_Mastiff\\media\\Smoothv2"
local border = "Interface\\AddOns\\oUF_Mastiff\\media\\border"
local font = "Interface\\AddOns\\oUF_Mastiff\\media\\ABF.ttf"
local height, width = 50, 200

-- Toggle Castbars
local castBars = true
local castsafeZone = false

-- Health Deficit(Healer Mode)
local deficit = false

RuneFrame:Hide() --------- Hides the Rune Frame, DKs will need to get a Rune Addon

local backdrop = {
	bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=], tile = true, tileSize = 16,
	insets = {top = -1.5, left = -1.5, bottom = -1.5, right = -1.5},
}

local colors = setmetatable({
	power = setmetatable({
		['MANA'] = {.31,.45,.63},
		['RAGE'] = {.69,.31,.31},
		['FOCUS'] = {.71,.43,.27},
		['ENERGY'] = {.65,.63,.35},
		['RUNIC_POWER'] = {0,.8,.9},
	}, {__index = oUF.colors.power}),
}, {__index = oUF.colors})

oUF.Tags['[shortname]']  = function(u) local name = UnitName(u); if(name) then return name:sub(1, 15) else return '' end end
oUF.TagEvents['[shortname]']   = 'UNIT_NAME_UPDATE'

local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

-- Shorten Values
local function ShortValue(value)
	if value >= 1e7 then
		return ('%.1fm'):format(value / 1e6):gsub('%.?0+([km])$', '%1')
	elseif value >= 1e6 then
		return ('%.2fm'):format(value / 1e6):gsub('%.?0+([km])$', '%1')
	elseif value >= 1e5 then
		return ('%.0fk'):format(value / 1e3)
	elseif value >= 1e3 then
		return ('%.1fk'):format(value / 1e3):gsub('%.?0+([km])$', '%1')
	else
		return value
	end
end

-- Icon
local updateRIcon = function(self, event)
	local index = GetRaidTargetIndex(self.unit)
	if(index) then
		self.RIcon:SetText(ICON_LIST[index].."22|t")
	else
		self.RIcon:SetText()
	end
end


-- Health Function
local updateHealth = function(self, event, unit, bar, min, max)
	local perc = floor(min/max*100)
	if(not UnitIsConnected(unit)) then
		bar:SetValue(0)
		bar.value:SetText('|cffD7BEA5'..'Offline')
	elseif(unit == 'targettarget') then
		bar.value:SetText()
	elseif(UnitIsDead(unit)) then
		bar.value:SetText('|cffD7BEA5'..'Dead')
	elseif(UnitIsGhost(unit)) then
		bar.value:SetText('|cffD7BEA5'..'Ghost')
	elseif(self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target')then
 		bar.value:SetText()
        elseif(min==max) then
		bar.value:SetFormattedText(ShortValue(min))
	else
		if(deficit)then
			bar.value:SetFormattedText('|cffff3333'.. ShortValue(min-max).. "|cffffffff | " ..perc)
		else
 			bar.value:SetFormattedText(ShortValue(min).. " | " ..perc)
		end
	end

end


-- Power Function
local updatePower = function(self, event, unit, bar, min, max)
	if(min == 0 or UnitIsDead(unit) or UnitIsGhost(unit) or unit == "targettarget" or unit == "focus" or unit == "pet" or not UnitIsConnected(unit)) then
	  bar.value:SetText()
	elseif(self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target')then
 	  bar.value:SetText()
  	else
	  bar.value:SetFormattedText(ShortValue(min))
	end
	bar.value:SetTextColor(1,1,1)
end

-- Aura
local auraIcon = function(self, button, icons)
	local count = button.count
	count:ClearAllPoints()
	count:SetPoint("BOTTOM", button, 8, -4)
	icons.showDebuffType = true
	button.cd:SetReverse()
	button.overlay:SetTexture(border)
	button.overlay:SetTexCoord(0, 1, 0, 1)
	button.overlay.Hide = function(self) self:SetVertexColor(0.25, 0.25, 0.25) end
end
-- Style
local func = function(self, unit)
	self.colors = colors
	self.menu = menu

	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)

	self:RegisterForClicks"anyup"
	self:SetAttribute("*type2", "menu")
	-- Health
	local hp = CreateFrame"StatusBar"
	if (unit == 'player' or unit == "target" or self:GetParent():GetName():match'oUF_Party') then
	  if(self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target')then
 	    hp:SetHeight(height*0.38)
    	  else
	    hp:SetHeight(height*0.6)
    	  end
  	else
	  hp:SetHeight(height*0.38)
  	end
	hp:SetStatusBarTexture(texture)
	hp.colorTapping = true
	hp.colorHappiness = true
  	hp.colorClass = true
	hp.colorReaction = true
	

	-- Smooth
	hp.Smooth = true

	hp.frequentUpdates = true

	hp:SetParent(self)
	hp:SetPoint"TOP"
	hp:SetPoint"LEFT"
	hp:SetPoint"RIGHT"

	local hpbg = hp:CreateTexture(nil, "BORDER")
	hpbg:SetAllPoints(hp)
	hpbg:SetTexture(texture)
	hpbg.multiplier = .2

	self:SetBackdrop(backdrop)
	self:SetBackdropColor(0, 0, 0, .7)

	-- Health Text
	local hpp = hp:CreateFontString(nil, "OVERLAY")
	hpp:SetFont(font, 12)
	hpp:SetShadowOffset(1, -1)
	if(deficit)then
	  hpp:SetTextColor(8, 3, 3)
  	else
	  hpp:SetTextColor(1, 1, 1)
  	end
	hpp:SetPoint("RIGHT", hp, -2, 0)

	hp.bg = hpbg
	hp.value = hpp
	self.Health = hp
	self.PostUpdateHealth = updateHealth
	-- Power
	
	  local pp = CreateFrame"StatusBar"

	  if (unit == 'player' or unit == "target" or self:GetParent():GetName():match'oUF_Party') then
	    if(self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target')then
 	      pp:SetHeight(height*0.02)
      	    else
	      pp:SetHeight(height*0.4)
      	    end
	  else
	    pp:SetHeight(height*0.02)
    	  end
	  pp:SetStatusBarTexture(texture)
	  pp.colorPower = true
	  pp.frequentUpdates = true
	 
	  -- Smooth
	  pp.Smooth = false

	  pp:SetParent(self)
	  pp:SetPoint"BOTTOM"
	  pp:SetPoint"LEFT"
	  pp:SetPoint"RIGHT"

	  local ppbg = pp:CreateTexture(nil, "BORDER")
	  ppbg:SetAllPoints(pp)
	  ppbg:SetTexture(texture)
	  ppbg.multiplier = .2
	  
	  -- Power Text
	  local ppp = pp:CreateFontString(nil, "OVERLAY")
	  ppp:SetFont(font, 12)
	  ppp:SetShadowOffset(1, -1)
	  ppp:SetPoint("RIGHT", pp,-2, 0)
	  ppp:SetTextColor(1, 1, 1)

	  pp.value = ppp
	  pp.bg = ppbg
	  self.Power = pp
	  self.PostUpdatePower = updatePower
	
	
	
	-- CastBar
	if(castBars)then
	  if not (unit == "targettarget" or self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target') then
		local cb = CreateFrame"StatusBar"
		cb:SetStatusBarTexture(texture)
		-- CastBar Color
		cb:SetStatusBarColor(.9,.7,0)
		if(unit == 'focus' or unit =='pet')then
		  cb:SetWidth(150)
	  	else
		  cb:SetWidth(width)
	  	end
		cb:SetHeight(15)
		cb:SetParent(self)
		if(unit == 'target')then
		  cb:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", 15, -17)
		else
		  cb:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 0, -17)
		end
		cb:SetBackdrop(backdrop)
		cb:SetBackdropColor(0, 0, 0, .7)
		cb:SetToplevel(true)
		self.Castbar = cb
		self.Castbar.Text = self.Castbar:CreateFontString(nil, "OVERLAY")
		self.Castbar.Text:SetFont(font, 11)
		self.Castbar.Text:SetShadowOffset(1, -1)
		self.Castbar.Text:SetPoint("LEFT", self.Castbar, "LEFT", 2, 0)
		self.Castbar.Time = self.Castbar:CreateFontString(nil, 'OVERLAY')
		self.Castbar.Time:SetFont(font, 11)
		self.Castbar.Time:SetShadowOffset(1, -1)
		self.Castbar.Time:SetPoint("RIGHT", self.Castbar, "RIGHT",  -2, 0)
		self.Castbar.CustomTimeText = function(self, duration)
                  if self.casting then
                    self.Time:SetFormattedText("%.1f", self.max - duration)
                  elseif self.channeling then
                    self.Time:SetFormattedText("%.1f", duration)
                  end
	  	end
		if(castsafeZone and unit == 'player') then
		  self.Castbar.SafeZone = self.Castbar:CreateTexture(nil,'ARTWORK')
		  self.Castbar.SafeZone:SetPoint('TOPRIGHT')
		  self.Castbar.SafeZone:SetPoint('BOTTOMRIGHT')
		  self.Castbar.SafeZone:SetTexture(texture)
		  self.Castbar.SafeZone:SetVertexColor(.69,.31,.31)
		end
		if not(unit == 'focus' or unit == 'pet')then
		self.Castbar.Icon = self.Castbar:CreateTexture(nil, 'ARTWORK')
		self.Castbar.Icon:SetHeight(15)
		self.Castbar.Icon:SetWidth(15)
		self.Castbar.Icon:SetTexCoord(0.1,0.9,0.1,0.9)
		self.Castbar.Icon:SetPoint('LEFT', -16, 0)
		end

	  end

	end

	
	-- Leader Icon
	if(self:GetParent():GetName():match'oUF_Party' or unit == 'player') then
	  if not(self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target')then
	    local leader = hp:CreateTexture(nil, "OVERLAY")
	    leader:SetHeight(16)
	    leader:SetWidth(16)
	    leader:SetPoint("BOTTOMLEFT", hp, "TOPLEFT", -5, -7)
	    leader:SetTexture"Interface\\GroupFrame\\UI-Group-LeaderIcon"
	    self.Leader = leader
	  
	    self.ReadyCheck = hp:CreateTexture(nil, 'OVERLAY')
	    self.ReadyCheck:SetHeight(24)
	    self.ReadyCheck:SetWidth(24)
	    self.ReadyCheck:SetPoint('CENTER')
	  
	    local portrait = CreateFrame("PlayerModel", nil, self)
	    portrait:SetBackdrop(backdrop)
	    portrait:SetBackdropColor(0, 0, 0, .7)
	    portrait:SetScript("OnShow", function(self) self:SetCamera(0) end)
	    portrait:SetWidth(height)
	    portrait:SetHeight(height)
	    portrait:SetPoint("BOTTOMRIGHT", self, "BOTTOMLEFT", -2, 0)
	    portrait.type = "3D"
	    self.Portrait = portrait
  	  end
	  
	end
	
	--PvP
	local pvp = hp:CreateTexture(nil, "OVERLAY")
	pvp:SetPoint("BOTTOMRIGHT", hp, "TOPRIGHT", 18, -20)
	pvp:SetHeight(28)
	pvp:SetWidth(28)
	self.PvP = pvp
	
	-- Raid Icon
	local ricon = hp:CreateFontString(nil, "OVERLAY")
	ricon:SetFontObject(GameFontNormalSmall)
	ricon:SetTextColor(1, 1, 1)
	ricon:SetPoint("CENTER", hp, 0, 12)
	ricon:SetHeight(24)
	ricon:SetWidth(24)
	self.RIcon = ricon
	self:RegisterEvent("RAID_TARGET_UPDATE", updateRIcon)
	table.insert(self.__elements, updateRIcon)

	
	if(unit~='player')then
	-- Name
	  local name = hp:CreateFontString(nil, "OVERLAY")
	  if(unit == "targettarget") then
	      name:SetPoint("CENTER")
	  else
	      name:SetPoint("LEFT", hp, 2, 0)
	      name:SetJustifyH"LEFT"
	  end
	  name:SetFont(font, 12)
 	  name:SetTextColor(1, 1, 1)
	  name:SetShadowOffset(1, -1)
	  self.Info = name
	  self:Tag(self.Info,'[shortname]')
	end 
	--Class
	if not (unit == "targettarget" or unit == 'focus' or unit == 'pet' or self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target') then
	  local class = pp:CreateFontString(nil, "OVERLAY")
	  class:SetPoint("LEFT")
	  class:SetFont(font, 11)
 	  class:SetTextColor(1, 1, 1)
	  class:SetShadowOffset(1, -1)
	  self.Info = class 
	  self:Tag(self.Info,' [difficulty][smartlevel] [raidcolor][smartclass]')
  	end

	-- Buffs
	if(unit == "target") then
		local buffs = CreateFrame("Frame", nil, self)
		buffs:SetHeight(25)
		buffs:SetWidth(6*25)
		buffs.initialAnchor = "TOPLEFT"
		buffs.num = 15
		buffs["growth-y"] = "DOWN"
		buffs.size = 25
		buffs.spacing = 2
		
		-- Combo Points
		self.CPoints = self:CreateFontString(nil, 'OVERLAY')
		self.CPoints:SetFont(font, 18)
		self.CPoints:SetPoint('RIGHT', self, 'LEFT', -2, 0)
		self.CPoints:SetTextColor(.8, .8, 0)
		self.CPoints:SetShadowOffset(1, -1)
		self.CPoints:SetJustifyH('RIGHT')
		self.CPoints.unit = 'player'

		local portrait = CreateFrame("PlayerModel", nil, self)
	  	portrait:SetBackdrop(backdrop)
		portrait:SetBackdropColor(0, 0, 0, .7)
		portrait:SetScript("OnShow", function(self) self:SetCamera(0) end)
		portrait:SetWidth(height)
		portrait:SetHeight(height)
		portrait:SetPoint("BOTTOMLEFT", self, "BOTTOMRIGHT", 2, 0)
		portrait.type = "3D"
		self.Portrait = portrait

		buffs:SetPoint("TOPLEFT", portrait, "TOPRIGHT", 4, 0)
		self.Buffs = buffs
	end

	if(unit) then
	    local debuffs = CreateFrame("Frame", nil, self)
	    debuffs:SetHeight(25)
	    debuffs:SetWidth(10*25)
	  if(unit == 'focus') then
		  debuffs:SetPoint("LEFT", self, "RIGHT", 2, 0)
		  debuffs["growth-x"] = "RIGHT"
		  debuffs.initialAnchor = "LEFT"
	  elseif(unit == 'player' or unit == 'targettarget') then
		  debuffs:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 4)
		  debuffs["growth-x"] = "LEFT"
		  debuffs.initialAnchor = "BOTTOMRIGHT"
	  else
		  debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 4)
		  debuffs["growth-y"] = "UP"
		  debuffs.initialAnchor = "TOPLEFT"
	  end
	    debuffs.size = 25		
	    debuffs.spacing = 2
	  if(unit == "targettarget" or unit == "focus" or unit == "player") then
	    debuffs.num = 5
    	  else
	    debuffs.num = 20
	  end
	    self.Debuffs = debuffs
	end	

	if(unit == 'player' and UnitLevel('player') ~= MAX_PLAYER_LEVEL) then
		self.Resting = self.Power:CreateTexture(nil, 'OVERLAY')
		self.Resting:SetHeight(16)
		self.Resting:SetWidth(18)
		self.Resting:SetPoint('BOTTOMLEFT', -8.5, -8.5)
		self.Resting:SetTexture('Interface\\CharacterFrame\\UI-StateIcon')
		self.Resting:SetTexCoord(0,0.5,0,0.421875)
	end


	-- DebuffHidghtlight
	self.DebuffHighlightBackdrop = true
	self.DebuffHighlightFilter = true

	if(unit == 'player' or unit == 'pet' or unit == 'focus') then
		-- BarFader
		self.BarFade = true

		-- Experience
		if(IsAddOnLoaded('oUF_Experience') and unit == 'player') then
			self.Experience = CreateFrame('StatusBar', nil, self)
			self.Experience:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', 0, -20)
			self.Experience:SetStatusBarTexture(texture)
			self.Experience:SetStatusBarColor(0,.7,1)
			self.Experience:SetHeight(11)
			self.Experience:SetWidth(width)
			self.Experience:SetBackdrop(backdrop)
			self.Experience:SetBackdropColor(0, 0, 0)

			self.Experience.Tooltip = true

			self.Experience.Text = self.Experience:CreateFontString(nil, 'OVERLAY')
			self.Experience.Text:SetFont(font, 10)
			self.Experience.Text:SetShadowOffset(1, -1)
			self.Experience.Text:SetPoint('CENTER', self.Experience)

			self.Experience.bg = self.Experience:CreateTexture(nil, 'BORDER')
			self.Experience.bg:SetAllPoints(self.Experience)
			self.Experience.bg:SetTexture(0.25, 0.25, 0.25)
		end

	end

	-- CombatFeedback
	  local cbft = hp:CreateFontString(nil, "OVERLAY")
	  cbft:SetPoint("CENTER", self, 0, 0)
	  cbft:SetFont(font, 12, "OUTLINE")
	  self.CombatFeedbackText = cbft
	  self.CombatFeedbackText.maxAlpha = 1

	if(unit == 'pet') then
		self:RegisterEvent("UNIT_HAPPINESS", updateHealth)
	end

	if(not unit) then
		self.Range = true
		self.inRangeAlpha = 1
		self.outsideRangeAlpha = .5
	end

	if(unit == "targettarget" or unit == "focus" or unit == "pet") then 
	  self:SetAttribute('initial-height', height*0.4)
	  self:SetAttribute('initial-width', 150)
	elseif(self:GetAttribute('unitsuffix') == 'pet' or self:GetAttribute('unitsuffix') == 'target')then
	  self:SetAttribute('initial-height', height*0.4)
	  self:SetAttribute('initial-width', 125)
  	elseif(self:GetParent():GetName():match'oUF_Party')then
	  self:SetAttribute('initial-height', height)
	  self:SetAttribute('initial-width', 164)
	else 
	  self:SetAttribute('initial-height', height)
	  self:SetAttribute('initial-width', width)
	end

	self.disallowVehicleSwap = true

	self.PostCreateAuraIcon = auraIcon

	return self
end

oUF:RegisterStyle("Mastiff", func)

oUF:SetActiveStyle"Mastiff"

local player = oUF:Spawn("player")
player:SetPoint("CENTER", UIParent, -200, -250)
local target = oUF:Spawn("target")
target:SetPoint("CENTER", UIParent, 200, -250)

local tot = oUF:Spawn("targettarget")
tot:SetPoint("CENTER", UIParent, 0, -250)
local pet = oUF:Spawn("pet")
pet:SetPoint("TOPRIGHT", oUF.units.player, "TOPLEFT", -(height + 8), 0)
local focus = oUF:Spawn("focus")
focus:SetPoint("BOTTOMLEFT", oUF.units.player, "TOPLEFT", -170, 28)

local party = oUF:Spawn("header", "oUF_Party")
party:SetPoint("TOPLEFT", UIParent, 55, -180)
party:SetManyAttributes("showParty", true, "yOffset", -20)
party:SetAttribute("template", "oUF_MastiffParty")


local partyToggle = CreateFrame('Frame')
partyToggle:RegisterEvent('PLAYER_LOGIN')
partyToggle:RegisterEvent('RAID_ROSTER_UPDATE')
partyToggle:RegisterEvent('PARTY_LEADER_CHANGED')
partyToggle:RegisterEvent('PARTY_MEMBERS_CHANGED')
partyToggle:SetScript('OnEvent', function(self)
party:Show()
end)


